customer = new.tableRef("customer", "PostgreSQL", "postgre.config", "tpch")
orders = new.tableRef("orders", "PostgreSQL", "postgre.config", "tpch")
lineitem = new.tableRef("lineitem", "PostgreSQL", "postgre.config", "tpch")
nation = new.tableRef("nation", "PostgreSQL", "postgre.config", "tpch")
q =
order(function(x) c(x$revenue), function(x) c(FALSE),
group(function(x) c(x$c_custkey, x$c_name, x$c_acctbal, x$c_phone, x$n_name, x$c_address, x$c_comment),
select(function(x){
  y = new.env()
  y$c_custkey = x$c_custkey
  y$c_name = x$c_name
  y$revenue = sum(x$l_extendedprice * (1 - x$l_discount))
  y$c_acctbal = x$c_acctbal
  y$n_name = x$n_name
  y$c_address = x$c_address
  y$c_phone = x$c_phone
  y$c_comment = x$c_comment
  y
},
where(function(x) x$o_orderdate >= date("1993-10-01")
  && x$o_orderdate < date("1993-10-01") + interval(3, "month")
  && x$l_returnflag == "R",
join(from(nation),
join(from(customer),
join(from(lineitem),
     from(orders),
     function(x, y) x$l_orderkey == y$o_orderkey),
     function(x, y) x$c_custkey == y$o_custkey),
     function(x, y) x$n_nationkey == y$c_nationkey)))))
print(query.force(q))
